%define pyver %(python -c 'import sys ; print sys.version[:3]')
%define pynext %(python -c 'print %{pyver} + 0.1')
Name:           Pyrex
Version:        0.9
Release:        0.fdr.4.2
Epoch:          0
BuildArch:	noarch
Summary:        A compiler/language for writing Python extension modules.
Group:          Development/Languages
License:        Public Domain
URL:            http://www.cosc.canterbury.ac.nz/~greg/python/Pyrex/
Source0:        http://www.cosc.canterbury.ac.nz/~greg/python/Pyrex/Pyrex-0.9.tar.gz
# Will no longer be needed when FC migrates from python 2.2 to python 2.3
Patch0:		http://www.tiki-lounge.com/~toshio/fedora/Pyrex-longlong.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  python-devel 
BuildRequires:  dos2unix
BuildRequires:  findutils
Requires: python >= 0:%{pyver}, python <= 0:%{pynext}

%description
Pyrex is Python with C types.  It is specially designed to allow you to
write extension modules for Python that have the speed of C and the
simplicity and readability of Python.  You write your code in a Python-like
language with C-typed variables, then use the pyrexc compiler to transform
it into a C representation.  This is useful for speeding up critical sections
of your Python code or wrapping an external library.

Please see the documentation for how to get the best performance from your
code.

%prep
%setup -q
%patch0 -p1

%build
python setup.py build 

# Remove some Macintosh-isms
find . -name '.DS_Store' -exec rm -f \{\} \;
dos2unix -k -c mac CHANGES.txt ToDo.txt Tools/* Doc/* Demos/Makefile.nodistutils
dos2unix -k -c mac Demos/callback/cheesefinder.h Demos/callback/Makefile.nodistutils Demos/callback/README.txt
dos2unix -k -c mac Demos/embed/Makefile.msc Demos/embed/Makefile.msc.static Demos/embed/README

%install
rm -rf $RPM_BUILD_ROOT
python setup.py install --skip-build --root $RPM_BUILD_ROOT --record=INSTALLED_FILES
# Add directories to the INSTALLED_FILES
find $RPM_BUILD_ROOT%{_libdir}/python%{pyver}/site-packages/Plex -type d -print | \
sed "s|$RPM_BUILD_ROOT|%dir |g" >>INSTALLED_FILES
find $RPM_BUILD_ROOT%{_libdir}/python%{pyver}/site-packages/Pyrex -type d -print | \
sed "s|$RPM_BUILD_ROOT|%dir |g" >>INSTALLED_FILES

# Produce .pyo files for %ghost directive later (from duplicity)
python -Oc 'from compileall import *; compile_dir("'$RPM_BUILD_ROOT/%{_libdir}/python%{pyver}/site-packages/Plex'")'

python -Oc 'from compileall import *; compile_dir("'$RPM_BUILD_ROOT/%{_libdir}/python%{pyver}/site-packages/Pyrex'")'

%clean
rm -rf $RPM_BUILD_ROOT

%files -f INSTALLED_FILES
%defattr(0644,root,root,0755)
%doc USAGE.txt README.txt CHANGES.txt ToDo.txt Demos Doc Tools

%defattr(-,root,root,-)
%ghost %{_libdir}/python%{pyver}/site-packages/Plex/*.pyo
%ghost %{_libdir}/python%{pyver}/site-packages/Pyrex/*.pyo
%ghost %{_libdir}/python%{pyver}/site-packages/Pyrex/Compiler/*.pyo
%ghost %{_libdir}/python%{pyver}/site-packages/Pyrex/Distutils/*.pyo
%exclude %{_libdir}/python%{pyver}/site-packages/Pyrex/Mac

%changelog
* Mon Feb 02 2004 Toshio Kuratomi <toshio@tiki-lounge.com> - 0:0.9-0.fdr.4
- Removed the site-packages directory from the directories owned by the
  package

* Mon Feb 02 2004 Toshio Kuratomi <toshio@tiki-lounge.com> - 0:0.9-0.fdr.3
- My mistake: rpm automatically removes %%ghost files, no need to script
  it manually.
- python distutils --record=FILE option doesn't record directories so include
  the site-packages/[directories] manually

* Thu Jan 15 2003 Toshio Kuratomi <toshio@tiki-lounge.com> - 0:0.9-0.fdr.2
- Merge changes from Michel Alexandre Salim <salimma[AT]users.sf.net>
  + Require build system's python version because directories are named
    pythonX.Y
  + Create *.pyo files and %ghost them (Privleged user with python optimize
    turned on may generate them, but they aren't needed for operation.
  + Do not include the Mac Pyrex compiler stuff
  + Change license to Public Domain
- Script to remove any %%ghost files on package removal
- Patch around an incompatible change between python 2.2 and python 2.3's
  definition of LONG_LONG being renamed to PY_LONG_LONG
  
* Fri Jan 09 2003 Toshio Kuratomi <toshio@tiki-lounge.com> - 0:0.9-0.fdr.1
- Initial RPM release.
